
var data = [];
var columns = ["No","Name","Position"];
var positions = { G:"Goalkeeper", D:"Defender", M:"Midfielder", F:"Forward" };

var table = d3.select("#roster")
  .append("table")
  .classed("table", true);

var thead = table.append("thead");

var tbody = table.append("tbody");

var reload = function() {
  d3.tsv("afcw-roster.tsv", function(records) {
    data = records;
    data.forEach(function(d) { d.Position = positions[d.Pos]; });
    redraw();
  });
};

var redraw = function() {
  thead.selectAll("tr")
    .data([columns])
    .enter()
    .append("tr")
    .selectAll("th")
    .data(function(d) { return d; })
    .enter()
    .append("th")
    .text(function(d) { return d; });
  
  var rows = tbody.selectAll("tr")
    .data(data);
    
  rows.enter().append("tr");
  rows.exit().remove();
  
  var cells = rows.selectAll("td")
    .data(function(row) { return columns.map(function(col) {
      return row[col];
    });});
    
  cells.enter().append("td");
  
  cells.text(function(d) { return d; });
};

reload();
